%eden

/*
 * Chessboard is represented by a list (numbered from 1 to 64 by ix)
 */

ChessBoard is [piece1, piece2, piece3, piece4, piece5, piece6, piece7, piece8, piece9, piece10, piece11,
piece12, piece13, piece14, piece15, piece16, piece17, piece18, piece19, piece20, piece21, piece22, piece23, piece24,
piece25, piece26, piece27, piece28, piece29, piece30, piece31, piece32, piece33, piece34, piece35, piece36, piece37,
piece38, piece39, piece40, piece41, piece42, piece43, piece44, piece45, piece46, piece47, piece48, piece49, piece50,
piece51, piece52, piece53, piece54, piece55, piece56, piece57, piece58, piece59, piece60, piece61, piece62, piece63,
piece64];

ChessNumber is ["A1", "B1", "C1", "D1", "E1", "F1", "G1", "H1", "A2", "B2", "C2", "D2",
"E2", "F2", "G2", "H2", "A3", "B3", "C3", "D3", "E3", "F3", "G3", "H3", "A4",
"B4", "C4", "D4", "E4", "F4", "G4", "H4", "A5", "B5", "C5", "D5", "E5", "F5",
"G5", "H5", "A6", "B6", "C6", "D6", "E6", "F6", "G6", "H6", "A7", "B7", "C7",
"D7", "E7", "F7", "G7", "H7", "A8", "B8", "C8", "D8", "E8", "F8", "G8", "H8"];

for (i = 1; i <= 64; i++) {
	execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
}

currentpiece = "";


/*
 * Here stores all the value which related to each other inside EDEN
 * Also, values which update the Scout output box is defined here
 */

thismoveboard = "";
lastmoveboard = "";
checked = "";
checkstring is checked;
whoseturnstring is toplay;
currentpiecestring is (`"piece"//str(int(pieceSelected))`);
lastpiecestring is lastpiece;
gamestatusstring is winner;
winner = "Game in progress";
fromstring is str(lastmoveboard);
tostring is str(thismoveboard);
pieceloststring is dummypiece;
end_of_game is (player1win == 1) || (player2win == 1);
player1win is checkwinplayer1(ChessBoard);
player2win is checkwinplayer2(ChessBoard);

/*
 * Function to check the winner by checking the remain of "k" or "K"
 */
func checkwinplayer1 {
	auto result;
	result = 1;
	for (i=1;i<=64;i++) {
		if (`"piece"//str(i)` == "k") {
			result = 0;
		}
	}
	if (result == 1) {
		winner = "Black won!!!";
	}
	return result;
}

func checkwinplayer2 {
	auto result;
	result = 1;
	for (i=1;i<=64;i++) {
		if (`"piece"//str(i)` == "K") {
			result = 0;
		}
	}
	if (result == 1) {
		winner = "White won!!!";
	}
	return result;
}

proc TheEnd : end_of_game {
	if (end_of_game == 1) {
		writeln("The End!!!");
		toplay = "non";
		writeln("Please reset the game if you want new game!!!");
	}
}

/*
 * Count parts are for counting that the rook and king has moved or not
 * Used to check for the castling chance.
 * Count1,2,3 = 2 black rooks and king
 * Count4,5,6 = 2 white rooks and kings
 * Castling1,2,3,4 is used to know that castling is done or not (used to perform undo)
 */

count1 = 0;
count2 = 0;
count3 = 0;
count4 = 0;
count5 = 0;
count6 = 0;
castling1 = 0;
castling2 = 0;
castling3 = 0;
castling4 = 0;

lastpiece = "";
lastmove = 0;
thismove = 0;

/*
 * The current player
 */

toplay = "Black";

moveNumber = 1;

func checkblank {
	para ix;
	auto result;
	blank = "";
	if(`"piece"//str(ix)` == blank) {
		result = 0;
	} else result = 1;
	return result;
}

/*
 * Function to make a move on the chess board, this works like you enter the position
 * of the chess piece and the position you want to move. If the position is right, the
 * function will swap 2 position, then give the blank value for the old position. You
 * just need to enter the position, the function will figure out the current piece and
 * current possible moves. Also switch player after a succesfully move.
 */

func makemove {
	para ix, ix2;
	result = [];
	writeln("Chess piece selected: " // `"piece"//str(ix)`);
	writeln("Moved from: " // str(ix) // " --- Move to: " // str(ix2));
	switch (`"piece"//str(ix)`) {
               	case "R": 
			makeBlackRookMove(ix, ix2);
			break;
		case "P": 
			makeBlackPawnMove(ix, ix2);
			break;
		case "K": 
			makeBlackKingMove(ix, ix2);
			break;
               	case "N":
			makeBlackKnightMove(ix, ix2);
			break;
            	case "Q":
			makeBlackQueenMove(ix, ix2);
			break;
		case "B":
			makeBlackBishopMove(ix, ix2);
			break;
		case "r": 
			makeWhiteRookMove(ix, ix2);
			break;
		case "p": 
			makeWhitePawnMove(ix, ix2);
			break;
		case "k": 
			makeWhiteKingMove(ix, ix2);
			break;
               	case "n":
			makeWhiteKnightMove(ix, ix2);
			break;
            	case "q":
			makeWhiteQueenMove(ix, ix2);
			break;
		case "b":
			makeWhiteBishopMove(ix, ix2);
			break;
        }
	writeln("########");
	writeln("");
	writeln(piece57, piece58, piece59, piece60, piece61, piece62, piece63, piece64);
	writeln(piece49, piece50, piece51, piece52, piece53, piece54, piece55, piece56);
	writeln(piece41, piece42, piece43, piece44, piece45, piece46, piece47, piece48);
	writeln(piece33, piece34, piece35, piece36, piece37, piece38, piece39, piece40);
	writeln(piece25, piece26, piece27, piece28, piece29, piece30, piece31, piece32);
	writeln(piece17, piece18, piece19, piece20, piece21, piece22, piece23, piece24);
	writeln(piece9, piece10, piece11, piece12, piece13, piece14, piece15, piece16);
	writeln(piece1, piece2, piece3, piece4, piece5, piece6, piece7, piece8);
	writeln("");
	writeln("########");
}

/* 
 * Function to check that the number is in the list or not
 */
func isinls {
	para ix, ls;
	auto result;
	result = 0;
	while (ls!=[]) {
			if (ls[1]==ix) result = 1;
			shift ls;
	}
	return result;
}



func dummy {
	return 0;
}

/*
 * Function to check that the chess board include any checkmate case.
 * There are 2 functions of checkmate, one for the black and the other for white
 * The function check every square on the chess board to get every chess pieces
 * then get all the possile moves of them and see if a checkmate case is there.
 */

func ischeckmateblack {
	auto result, upperlist, listcheckblack;
	listcheckblack = [];
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = 0;
	for (i=1;i<=64;i++) {
		if (isinls(`"piece"//str(i)`,upperlist) == 1) {
			switch (`"piece"//str(i)`) {
				case "R":
					listcheckblack = rookmoves(i);
					break;
				case "N":
					listcheckblack = knightmoves(i);
					break;
				case "B":
					listcheckblack = bishopmoves(i);
					break;
				case "K":
					listcheckblack = kingmoves(i);
					break;
				case "Q":
					listcheckblack = queenmoves(i);
					break;
				case "P":
					listcheckblack = pawnmoves(i);
					break;
				default:
					listcheckblack = [];
			}
			while (listcheckblack != []) {
				if (`"piece"//str(listcheckblack[1])` == "k") {
					result = 1;
					break;
				}
				shift listcheckblack;
			}
		}
	}
	return result;
}
func ischeckmatewhite {
	auto result, lowerlist, listcheckwhite;
	listcheckwhite = [];
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	result = 0;
	for (i=1;i<=64;i++) {
		if (isinls(`"piece"//str(i)`,lowerlist) == 1) {
			switch (`"piece"//str(i)`) {
				case "r":
					listcheckwhite = rookmoves(i);
					break;
				case "n":
					listcheckwhite = knightmoves(i);
					break;
				case "b":
					listcheckwhite = bishopmoves(i);
					break;
				case "k":
					listcheckwhite = kingmoves(i);
					break;
				case "q":
					listcheckwhite = queenmoves(i);
					break;
				case "p":
					listcheckwhite = pawnmoves(i);
					break;
				default:
					listcheckwhite = [];
			}
			while (listcheckwhite != []) {
				if (`"piece"//str(listcheckwhite[1])` == "K") {
					result = 1;
					break;
				}
				shift listcheckwhite;
			}
		}
	}
	return result;
}

/*
 * Function of checking there is any chance for making a castling in black or white player
 * A castling can be done if the king and rook never moved before, the king cannot pass
 * through a square that have been on the enemy attack row.
 */

func iscastlingblack1 {
	auto result;
	result = 0;
	if ((count1 == 0) && (count3 == 0) && (`"piece"//str(2)` == "") && (`"piece"//str(3)` == "") 
	&& (`"piece"//str(4)` == "") && (ischeckmatewhite() == 0)) {
		`"piece"//str(4)` = "K";
		if (ischeckmatewhite() == 0) {
			result = 1;
		}
		`"piece"//str(4)` = "";
	}
	return result;
}

func iscastlingblack2 {
	auto result;
	result = 0;
	if ((count2 == 0) && (count3 == 0) && (`"piece"//str(6)` == "") && (`"piece"//str(7)` == "") 
	&& (ischeckmatewhite() == 0)) {
		`"piece"//str(6)` = "K";
		if (ischeckmatewhite() == 0) {
			result = 1;
		}
		`"piece"//str(6)` = "";
	}
	return result;
}

func iscastlingwhite1 {
	auto result;
	result = 0;
	if ((count4 == 1) && (count6 == 0) && (`"piece"//str(58)` == "") && (`"piece"//str(59)` == "") 
	&& (`"piece"//str(60)` == "") && (ischeckmateblack() == 0)) {
		`"piece"//str(60)` = "k";
		if (ischeckmateblack() == 0) {
			result = 1;
		}
		`"piece"//str(60)` = "";
	}
	return result;
}

func iscastlingwhite2 {
	auto result;
	result = 0;
	if ((count5 == 1) && (count6 == 0) && (`"piece"//str(62)` == "") && (`"piece"//str(63)` == "") 
	&& (ischeckmateblack() == 0)) {
		`"piece"//str(62)` = "k";
		if (ischeckmateblack() == 0) {
			result = 1;
		}
		`"piece"//str(62)` = "";
	}
	return result;
}


/*
 * Function used in makemove to shorten the length of the function
 */

func makeBlackRookMove {
	para ix, ix2;
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = rookmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (int(ix) == 1) {
				count1++;
			}
			if (int(ix) == 8) {
				count2++;
			}
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				if (int(ix) == 1) {
					count1--;
				}
				if (int(ix) == 8) {
					count2--;
				}
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeBlackPawnMove {
	para ix, ix2;
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		result = pawnmoves(int(ix));
		dummylasmove = lastmove;
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (int(ix2) - int(ix) == 7) {
				if ((isinls(`"piece"//str(int(ix) - 1)`,lowerlist) == 1) && (`"piece"//str(int(ix) + 7)` == "")) {
					`"piece"//str(int(ix) - 1)` = "";	
				}
			}
			if (int(ix2) - int(ix) == 9) {
				if ((isinls(`"piece"//str(int(ix) + 1)`,lowerlist) == 1) && (`"piece"//str(int(ix) + 9)` == "")) {
					`"piece"//str(int(ix) + 1)` = "";	
				}
			}
			if (int(ix2) > 56) {
				writeln("Enter the number you want this pawn to change to:");
				writeln("1: Rook");
				writeln("2: Knight");
				writeln("3: Bishop");
				writeln("4: Queen");
				select = gets();
				switch(select) {
					case "1":
						`"piece"//str(ix2)` = "R";
						break;
					case "2":
						`"piece"//str(ix2)` = "N";
						break;
					case "3":
						`"piece"//str(ix2)` = "B";
						break;
					case "4":
						`"piece"//str(ix2)` = "Q";
						break;
				}
			}
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeBlackKingMove {
	para ix, ix2;
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = kingmoves(int(ix));
		castable1 = 0;
		castable2 = 0;
		if (isinls(int(ix2), result) == 1) {
			if (iscastlingblack1() == 1) {
				castable1 = 1;
			}
			if (iscastlingblack2() == 1) {
				castable2 = 1;
			}
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			count3++;
			if ((int(ix) == 5) && (int(ix2) == 3) && (castable1 == 1)) {
				piece1 = "";
				piece4 = "R";
				BlackRook1position = 4;
				castable1 = 0;
				castling1 = 1;
			}
			if ((int(ix) == 5) && (int(ix2) == 7) && (castable2 == 1)) {
				piece8 = "";
				piece6 = "R";
				BlackRook2position = 6;
				castable2 = 0;
				castling2 = 1;
			}
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = "K";
				writeln("You cannot make this move, under checked");
				count3--;
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeBlackBishopMove {
	para ix, ix2;
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = bishopmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeBlackKnightMove {
	para ix, ix2;
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = knightmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeBlackQueenMove {
	para ix, ix2;
	if (toplay == "Black") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = queenmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmatewhite() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = "Q";
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmateblack() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "White";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is black chess pieces!!");
	}
}

func makeWhiteRookMove {
	para ix, ix2;
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = rookmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (int(ix) == 57) {
				count4++;
			}
			if (int(ix) == 64) {
				count5++;
			}
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				if (int(ix) == 57) {
					count4--;
				}
				if (int(ix) == 64) {
					count5--;
				}
				returnNumber = 0;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

func makeWhitePawnMove {
	para ix, ix2;
	upperlist = ["R", "Q", "B", "P", "N", "K"];
	lowerlist = ["r", "q", "b", "p", "n", "k"];
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = pawnmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (int(ix) - int(ix2) == 7) { 
				if ((isinls(`"piece"//str(int(ix) + 1)`,upperlist) == 1) && (`"piece"//str(int(ix) - 7)` == ""))  {
					`"piece"//str(int(ix) + 1)` = "";	
				}
			}
			if (int(ix) - int(ix2) == 9) {
				if ((isinls(`"piece"//str(int(ix) - 1)`,upperlist) == 1) && (`"piece"//str(int(ix) - 9)` == ""))  {
					`"piece"//str(int(ix) - 1)` = "";	
				}
			}
			if (int(ix2) < 8) {
				writeln("Enter the number you want this pawn to change to:");
				writeln("1: Rook");
				writeln("2: Knight");
				writeln("3: Bishop");
				writeln("4: Queen");
				select = gets();
				switch(select) {
					case "1":
						`"piece"//str(ix2)` = "r";
						break;
					case "2":
						`"piece"//str(ix2)` = "n";
						break;
					case "3":
						`"piece"//str(ix2)` = "b";
						break;
					case "4":
						`"piece"//str(ix2)` = "q";
						break;
				}
			}
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

func makeWhiteKingMove {
	para ix, ix2;
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = kingmoves(int(ix));
		castable1 = 0;
		castable2 = 0;
		if (isinls(int(ix2), result) == 1) {
			if (iscastlingwhite1() == 1) {
				castable1 = 1;
			}
			if (iscastlingwhite2() == 1) {
				castable2 = 1;
			}
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			count6++;
			if ((int(ix) == 61) && (int(ix2) == 59) && (castable1 == 1)) {
				piece57 = "";
				piece60 = "r";
				WhiteRook1position = 60;
				castable = 0;
				castling3 = 1;
			}
			if ((int(ix) == 61) && (int(ix2) == 63) && (castable2 == 1)) {
				piece64 = "";
				piece62 = "r";
				WhiteRook1position = 62;
				castable = 0;
				castling4 = 1;
			}
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = "k";
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
				count6--;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

func makeWhiteKnightMove {
	para ix, ix2;
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = knightmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				`"piece"//str(ix)` = lastpiece;
				lastmove = dummylastmove;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

func makeWhiteQueenMove {
	para ix, ix2;
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = queenmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = "q";
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

func makeWhiteBishopMove {
	para ix, ix2;
	if (toplay == "White") {
		dummypiece = `"piece"//str(ix2)`;
		dummylasmove = lastmove;
		result = bishopmoves(int(ix));
		if (isinls(int(ix2), result) == 1) {
			lastpiece = `"piece"//str(ix)`;
			lastmove = int(ix);
			thismove = int(ix2);
			`"piece"//str(ix2)` = `"piece"//str(ix)`;
			`"piece"//str(ix)` = "";
			if (ischeckmateblack() == 1) {
				`"piece"//str(ix2)` = dummypiece;
				lastmove = dummylastmove;
				`"piece"//str(ix)` = lastpiece;
				writeln("You cannot make this move, under checked");
				returnNumber = 0;
			} else {
				if (ischeckmatewhite() == 1) {
					writeln("CHECK!!!");
					checked = "CHECK!!!";
				} else {
					checked = "";
				}
				movelist = movelist // [[moveNumber, lastmove, thismove, lastpiece, dummypiece]];
				moveNumber++;
				toplay = "Black";
				for (i = 1; i <= 64; i++) {
					execute("_L"//str(i)//" is label(piece"//str(i)//", cart(500,500));");
				}
			}
		}
	} else {
		writeln("This is White chess pieces!!");
	}
}

/*
 * Function Undo to undo the move of players. Undo up to 2 moves because "black" player
 * may want to undo their previous move, so the function needs to undo also the "white" move
 */
func undo {
	if (moveNumber > 2) {
		a = movelist[moveNumber+1];
		a2 = a[2];
		a3 = a[3];
		a4 = a[4];
		a5 = a[5];
		b = movelist[moveNumber];
		b2 = b[2];
		b3 = b[3];
		b4 = b[4];
		b5 = b[5];
		moveNumber--;
		`"piece"//str(a[3])` = str(a[5]);
		`"piece"//str(a[2])` = str(a[4]);
		thismove = b[3];
		lastmove = b[2];
		lastpiece = str(b[4]);
		dummypiece = str(b[5]);
		if (castling1 == 1) {
			piece1 = "R";
			piece4 = "";
			castling1 = 0;
			count3--;
		}
		if (castling2 == 1) {
			piece8 = "R";
			piece6 = "";
			castling2 = 0;
			count3--;
		}
		if (castling3 == 1) {
			piece57 = "r";
			piece60 = "";
			castling3 = 0;
			count6--;
		}
		if (castling4 == 1) {
			piece64 = "r";
			piece62 = "";
			castling4 = 0;
			count6--;
		}
	/*
	 * TO DR MEURIG
	 * THIS FUNCTION IS NEARLY FINISHED, APART FROM HOW TO DELETE 1 NEWEST LINE FROM EDDI DATABASE "movelist"
	 * I HAVE EMAILED YOU BUT RECEIVED NO ANSWER, SO IF YOU KNOW HOW TO FIX THIS PROBLEM, PLEASE INSERT A CODE WHICH
	 * CAN DELETE THE NEWEST LINE INSIDE EDDI, THE PROBLEM WILL BE SOLVED. THANK YOU!
	 * CHARLIE
	 */

	}		
}
